(document:surround "/std/base")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-net-pptp")

;;; Functions
(define *new-name* (make-cell "ppp0"))

(define (read-iface . args)
  (woo-catch/message
    (thunk
      (iface enumref "/net-pptp/avail_iface")
      (status-value enumref "/net-pptp/avail_state")
      (connections enumref "/net-pptp/avail_connection")
      (let ((data (apply woo-read-first "/net-pptp/" args)))

	(and (positive? (connections count))
	     (connections value (woo-get-option data 'name)))

	(password value "")
	(cell-set! *new-name* (woo-get-option data 'new_name))
	(status-label text (woo-get-option data 'info))
	(server value (woo-get-option data 'server))
	(login value (woo-get-option data 'login))
	(iface value (woo-get-option data 'iface))
	(def-via-vpn state (woo-get-option data 'def_via_vpn))
	(save-route state (woo-get-option data 'save_route))
	(mppe state (woo-get-option data 'mppe))
	(persist state (woo-get-option data 'persist))
	(onboot state (woo-get-option data 'onboot))))))

(define (write-iface)
  (woo-catch/message
    (thunk
      (woo-write/constraints
	"/net-pptp"
	'commit #t
	'name (connections value)
	'status (status-value value)
	'server (server value)
	'login (login value)
	'password (password value)
	'iface (iface value)
	'def_via_vpn (def-via-vpn state)
	'save_route (save-route state)
	'mppe (mppe state)
	'persist (persist state)
	'onboot (onboot state)))))

(define (new-iface)
  (woo-catch/message
    (thunk
      (woo-write "/net-pptp" 'new #t 'new_name (cell-ref *new-name*))
      (read-iface 'new #t 'new_name (cell-ref *new-name*)))))

(define (delete-iface)
  (let ((name (connections value)))
    (and (not-empty-string? name)
	 (woo-catch/message
	   (thunk (woo-write "/net-pptp/" 'delete #t 'name (connections value))
		  (read-iface))))))

;;; UI

(gridbox 
  columns "100"

  (document:id new-button (button text (_ "New connection...")
				  align "left"
				  (when clicked (new-iface))))
  (separator)

  (splitbox 
    columns "30;70"
    (document:id connections (listbox (when selected (read-iface 'name (connections value)))))
    (gridbox 
      columns "0;100"
      ;;
      (label text (_ "Status:") align "right")
      (hbox align "left"
	    (document:id status-label (label))
	    (document:id status-value (combobox)))
      ;;
      (label text (_ "Server:") align "right")
      (document:id server (edit))
      ;;
      (label text (_ "Account:") align "right")
      (document:id login (edit))
      ;;
      (label text (_ "Password:") align "right")
      (document:id password (edit "" echo "stars"))
      ;;
      (label text (_ "Walk through interface:") align "right")
      (document:id iface (combobox widget-name "iface"))
      ;;
      (spacer)
      (document:id def-via-vpn (checkbox text (_ "Default route via VPN")))
      ;;
      (spacer)
      (document:id save-route (checkbox text (_ "Save route to VPN gateway")))
      ;;
      (spacer)
      (document:id mppe (checkbox text (_ "MPPE encryption")))
      ;;
      (spacer)
      (document:id persist (checkbox text (_ "Redial on hangup")))
      ;;
      (spacer)
      (document:id onboot (checkbox text (_ "Start at boot")))
      ;;
      (label colspan 2)
      ;;
      (spacer)
      (hbox
	align "left"
	(document:id apply-button
	  (button text (_ "Apply")
	    (when clicked (write-iface) (read-iface 'name (or (connections value) "")))))
	(document:id reset-button
	  (button text (_ "Reset")
	    (when clicked (read-iface 'name (or (connections value) "")))))
	(label text "    ")
	(document:id del-button (button text (_ "Delete connection") (when clicked (delete-iface))))))))

;;; Logic
(document:root (when loaded (read-iface)))

